//all comments and codes by T. Hara

#include <stdio.h>
#include <stdlib.h>

#define USAGE "usage: proc1 input-filename width height output-filename\n "

/***************
$B%3%s%Q%$%k$9$k$K$O(B
 make  $B$HF~NO$7$F$/$@$5$$(B

$B<B9T$9$k$K$O(B,
 proc $BF~NO%U%!%$%kL>(B $B2hA|$NI}(B $B2hA|$N9b$5(B $B=PNO%U%!%$%kL>(B

$B$N=g$GF~NO$7$F$/$@$5$$(B

*****************/

int width,height,i,j,ii,jj,header_size;
unsigned char *image,*image_out,*image_out2;

void get_args(int argc, char **argv)
{

//$B%3%^%s%I%i%$%s$N0z?t$N?t$N%A%'%C%/(B
  if(argc != 5)
    {
//      $B0z?t$N?t$,#58D$GL5$$>l9g$K$O(B,USAGE $B$rI=<($7$F=*N;(B
      fprintf(stderr, USAGE);
      exit(1);
    }

//$B2hA|$NI}$H9b$5$NFI$_9~$_(B
  width = atoi(argv[2]); printf("W = %d,", width);
  height = atoi(argv[3]); printf("H = %d,", height);
}


void image_read_char(char *filename,int offset,unsigned char *im)
{
     FILE *fp;

     if ((fp=fopen(filename,"rb")) == NULL){
       printf("File Open Error Occured!\n");
       exit(-1);
     }
     fseek(fp,offset,0);
     fread((unsigned char *)im,sizeof(char),width*height,fp);
     fclose(fp);
     printf("File Opening...: %s\n",filename);
}

void image_write_char(char *filename,
		      int w, int h,
		      unsigned char *im)
{
    FILE *fp;
    
    if ((fp=fopen(filename,"wb")) == NULL){
        printf("File Open Error Occured!\n");
        exit(-1);
    }
    fwrite((unsigned char *)im,sizeof(char), w * h, fp);
    fclose(fp);
}


int main(int argc, char **argv) 
{

  /*$B2hA|$NI}$H9b$5$NFI$_9~$_(B*/
  get_args(argc, argv);

  /*$B2hA|$rJ]B8$9$kG[Ns!J%a%b%jNN0h!K$N=`Hw(B*/
  /*$B$^$:F~NOMQ(B*/
  image = (unsigned char *)malloc(width*height*sizeof(char));
  /*$B%P%C%U%!(B,$B=PNOMQ(B*/
  image_out = (unsigned char *)malloc(width*height*sizeof(char));
  /*$B:F%5%s%W%j%s%0J]B8MQ(B*/
  image_out2= (unsigned char *)malloc(width/2*height/2*sizeof(char));

  /*$B2hA|%U%!%$%k$NFI$_9~$_(B*/
  header_size=0;
  image_read_char(argv[1],header_size,image);

  /*$B<!$K2hA|$N%N%$%:=|5n$r9T$$$^$9(B
   $BJ}K!$O(B,$B1i=,#4$K4p$E$-(B,3x3$B2hAG$NJ?3j2=$r9T$$$^$9(B*/
  convolve_smooth(image,image_out,width,height);


  /*$B<!$K2hA|$N:F%5%s%W%j%s%0$r9T$$$^$9!#(B
    $B$3$3$G$O!"2rA|EY$rH>J,$KMn$H$7$^$9(B*/
  resampling(image_out,image_out2,width,height);


  /*$B2hA|%U%!%$%k$NJ]B8(B*/
  image_write_char(argv[4],width/2,height/2,image_out2);

  return 0;
}
