//all comments and codes by T. Hara

#include <stdio.h>
#include <stdlib.h>
#include <math.h>

#define USAGE "usage: proc1 input-filename width height output-filename\n "


/***************
$B%3%s%Q%$%k$9$k$K$O(B  make  $B$HF~NO$7$F$/$@$5$$(B
$B<B9T$9$k$K$O(B, proc $BF~NO%U%!%$%kL>(B $B2hA|$NI}(B $B2hA|$N9b$5(B $B=PNO%U%!%$%kL>(B
$B$N=g$GF~NO$7$F$/$@$5$$(B
*****************/

/*$B%W%m%H%?%$%W@k8@(B $B$3$3$+$i(B*/
double get_average(unsigned char *in, int w, int h);
double get_var(unsigned char *in, int w, int h);

/*$B%W%m%H%?%$%W@k8@(B $B$3$3$^$G(B*/

int width,height,i,j,ii,jj,header_size;
unsigned char *image,*image_out,*image_out2;

void get_args(int argc, char **argv)
{
  if(argc != 5)
    {
      fprintf(stderr, USAGE);
      exit(1);
    }
  width = atoi(argv[2]); printf("W = %d,", width);
  height = atoi(argv[3]); printf("H = %d,", height);
}


void image_read_char(char *filename,int offset,unsigned char *im)
{
     FILE *fp;
     if ((fp=fopen(filename,"rb")) == NULL){
       printf("File Open Error Occured!\n");
       exit(-1);
     }
     fseek(fp,offset,0);
     fread((unsigned char *)im,sizeof(char),width*height,fp);
     fclose(fp);
     printf("File Opening...: %s\n",filename);
}

void image_write_char(char *filename,
		      int w, int h,
		      unsigned char *im)
{
    FILE *fp;
    if ((fp=fopen(filename,"wb")) == NULL){
        printf("File Open Error Occured!\n");
        exit(-1);
    }
    fwrite((unsigned char *)im,sizeof(char), w * h, fp);
    fclose(fp);
}


int main(int argc, char **argv) 
{

  double thresh1,var1;

  /*$B2hA|$NI}$H9b$5$NFI$_9~$_(B*/
  get_args(argc, argv);

  /*$B2hA|$rJ]B8$9$kG[Ns!J%a%b%jNN0h!K$N=`Hw(B*/
  /*$BF~NOMQ$H=PNOMQ(B*/
  image = (unsigned char *)malloc(width*height*sizeof(char));
  image_out = (unsigned char *)malloc(width*height*sizeof(char));

  /*$B2hA|%U%!%$%k$NFI$_9~$_(B*/
  header_size=0;  image_read_char(argv[1],header_size,image);

  /*$B<!$K2hA|$NJ?6QCM$r$7$i$Y$^$9!#$3$NCM$r8!=P$N$?$a$N$7$-$$CM$H$7$^$9(B
   $BJ}K!$O(B,$B1i=,#6$K4p$E$-$^$9(B*/

  thresh1 = get_average(image,width,height);
  var1 = get_var(image,width,height);
//  printf("var= %f,",var1);

  /*$B$7$-$ACM(Bthresh$B$H$=$NJ,;6$+$i7W;;$9$k$h$&$K$7$^$9!#(B
    $B$3$3$G!"$7$-$$CM$O!"J?6Q!\I8=`JP:9$N#2G\$H$7$^$9!#(B
    $B$=$NCM$G2hA|$N#2CM2=$r9T$$$^$9!#862hA|$O(Bimage,
    $B=PNO2hA|$O(B,image_out$B$KJ]B8$7$^$9(B */

  binarize_image(image,image_out,width,height,
		 (int)(thresh1 + 1.5 * sqrt(var1)));

  /*$B:G8e$K(B,$B#2CM2=$7$?2hA|$rJ]B8$7$^$9(B*/
  image_write_char(argv[4],width,height,image_out);

  return 0;
}
