//all comments and codes by T. Hara

#include <stdio.h>
#include <stdlib.h>
#include <math.h>

#define USAGE "usage: proc1 input-filename width height output-filename\n "

/***************
$B%3%s%Q%$%k$9$k$K$O(B  make  $B$HF~NO$7$F$/$@$5$$(B
$B<B9T$9$k$K$O(B, proc $BF~NO%U%!%$%kL>(B $B2hA|$NI}(B $B2hA|$N9b$5(B $B=PNO%U%!%$%kL>(B
$B$N=g$GF~NO$7$F$/$@$5$$(B
*****************/

/*$B%W%m%H%?%$%W@k8@(B $B$3$3$+$i(B*/
double get_average(unsigned char *in, int w, int h);
double get_var(unsigned char *in, int w, int h);
int labeling(unsigned char *in, unsigned char *out,
             int width, int height);   

/*$B%W%m%H%?%$%W@k8@(B $B$3$3$^$G(B*/

int width,height,i,j,ii,jj,header_size;
unsigned char *image,*image_out,*image_out2,*labelimage;

double feature[256][5];
/*$B%i%Y%k$4$H$NFCD'NL$rJ]B8$9$kG[Ns!#$?$H$($P(B,
$B%i%Y%kHV9f$4$H$K(B,[0]$B=E?4$N(Bx$B:BI8(B,[1]$B#y:BI8(B,[2]$BBg$-$5(B,
[3]$B1_7AEY(B,[4]$B2hAGCM$NJ?6Q$rJ]B8$9$k(B*/

void get_args(int argc, char **argv)
{
  if(argc != 5)
    {
      fprintf(stderr, USAGE);
      exit(1);
    }
  width = atoi(argv[2]); printf("W = %d,", width);
  height = atoi(argv[3]); printf("H = %d,", height);
}


void image_read_char(char *filename,int offset,unsigned char *im)
{
     FILE *fp;
     if ((fp=fopen(filename,"rb")) == NULL){
       printf("File Open Error Occured!\n");
       exit(-1);
     }
     fseek(fp,offset,0);
     fread((unsigned char *)im,sizeof(char),width*height,fp);
     fclose(fp);
     printf("File Opening...: %s\n",filename);
}

void image_write_char(char *filename,
		      int w, int h,
		      unsigned char *im)
{
    FILE *fp;
    if ((fp=fopen(filename,"wb")) == NULL){
        printf("File Open Error Occured!\n");
        exit(-1);
    }
    fwrite((unsigned char *)im,sizeof(char), w * h, fp);
    fclose(fp);
}


int main(int argc, char **argv) 
{

  double thresh1,var1,cx,cy,roundratio,label_pix_value;
  int number_of_label,i,lsize;

  /*$B2hA|$NI}$H9b$5$NFI$_9~$_(B*/
  get_args(argc, argv);

  /*$B2hA|$rJ]B8$9$kG[Ns!J%a%b%jNN0h!K$N=`Hw(B*/
  /*$BF~NOMQ$H=PNOMQ(B,$B%i%Y%k$D$-2hA|(B*/
  image = (unsigned char *)malloc(width*height*sizeof(char));
  image_out = (unsigned char *)malloc(width*height*sizeof(char));
  labelimage= (unsigned char *)malloc(width*height*sizeof(char));

  /*$B2hA|%U%!%$%k$NFI$_9~$_(B*/
  header_size=0;  image_read_char(argv[1],header_size,image);

  /*$B<!$K2hA|$NJ?6QCM$r$7$i$Y$^$9!#$3$NCM$r8!=P$N$?$a$N$7$-$$CM$H$7$^$9(B
   $BJ}K!$O(B,$B1i=,#6$K4p$E$-$^$9(B*/

  thresh1 = get_average(image,width,height);
  var1 = get_var(image,width,height);
//  printf("var= %f,",var1);

  /*$B$7$-$ACM(Bthresh$B$H$=$NJ,;6$+$i7W;;$9$k$h$&$K$7$^$9!#(B
    $B$3$3$G!"$7$-$$CM$O!"J?6Q!\I8=`JP:9$N#2G\$H$7$^$9!#(B
    $B$=$NCM$G2hA|$N#2CM2=$r9T$$$^$9!#862hA|$O(Bimage,
    $B=PNO2hA|$O(B,image_out$B$KJ]B8$7$^$9(B */

  binarize_image(image,image_out,width,height,
		 (int)(thresh1 + 1.5 * sqrt(var1)));


  /*$B<!$K#2CM2=$5$l$?2hA|$KBP$7$F(B,$B%i$Y%j%s%0$r9T$$$^$9(B*/

  number_of_label = labeling(image_out,labelimage,width,height);
  /*$B%i%Y%k$N:GBg?t$,J]B8$5$l$^$9(B */

//  printf("The number of labels = %d\n",number_of_label);

/* i $BHVL\$N%i%Y%k$N=E?4:BI8(B(cx ,cy),$BBg$-$5(B(lsize),
   $B1_7AEY(B(roundratio)$B$rD4$Y$k(B*/

  for(i=1;i<number_of_label+1;i++){
    labelsize(labelimage,i,width,height,&cx,&cy,&lsize);
    roundshape(labelimage,width,height,i,&roundratio);
    labelpixvalue(labelimage,image,width,height,i,&label_pix_value);

    printf("Label #=%3d, CtrPnt(%lf,%lf), Size=%5d, RRat=%lf, Lpixv=%lf\n",
	   i,cx,cy,lsize,roundratio,label_pix_value);

    feature[i][0]=cx;
    feature[i][1]=cy;
    feature[i][2]=(double)lsize;
    feature[i][3]=roundratio;
    feature[i][4]=label_pix_value;
  }

  fp_reduction(labelimage,width,height,number_of_label);

  /*$B:G8e$K(B,$B#2CM2=$7$?2hA|$rJ]B8$7$^$9(B*/
  image_write_char(argv[4],width,height,labelimage);

  return 0;
}

