// All copyrights reserved by Daisuke Fukuoka, Gifu University. 2005.

#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <math.h>
#include <sys/stat.h>
#include "dicom.h"

int Filesize(char *filename){     //t@CTCY𒲂ׂ
  struct stat   stat_buf;
  FILE          *fp;
  
  if(( fp = fopen(filename,"r"))==NULL ){
    printf("Can't Read Orignal \n");
    fclose(fp);
    return -1;
  }
  else{
    stat( filename, &stat_buf );
    fclose(fp);
    return( stat_buf.st_size );
  }  
}

void ReadFile(char *filename,char *data){		//t@Cǂ
  FILE *fp;
  int f_size;

  f_size=Filesize(filename);
  fp=fopen(filename,"rt");
  fread(data,f_size,sizeof(char),fp);
  fclose(fp);
}

//VXẽGfBA𒲂ׂ
int Endian(){
  union{ char c[2]; short s; }u;
  u.c[0]=0;  u.c[1]=0;
  u.s=1;
  if(u.c[0]==1) return 1;   //*****gGfBA***** Intel
  return 0;                 //*****[WGfBA***** SPARC PowerPC
}

//*****DICMT*****
int DicomCheck(char *data,int f_size){
  int i;
  
  for(i=0;i<f_size-4;i++)
    if(strncmp(data+i,"DICM",4)==0)
      return i+4*sizeof(char);  
  return 0;
}

//******uqIÎI*****
int VrCheck(char *data,int p){
  if(    strncmp(data+p,"AE",2)==0 || strncmp(data+p,"AE",2)==0
      || strncmp(data+p,"AS",2)==0 || strncmp(data+p,"AT",2)==0
      || strncmp(data+p,"CS",2)==0 || strncmp(data+p,"DA",2)==0
      || strncmp(data+p,"DS",2)==0 || strncmp(data+p,"DT",2)==0
      || strncmp(data+p,"FL",2)==0 || strncmp(data+p,"FD",2)==0
      || strncmp(data+p,"IS",2)==0 || strncmp(data+p,"LO",2)==0
      || strncmp(data+p,"LT",2)==0 || strncmp(data+p,"OB",2)==0
      || strncmp(data+p,"OW",2)==0 || strncmp(data+p,"PN",2)==0
      || strncmp(data+p,"SH",2)==0 || strncmp(data+p,"SL",2)==0
      || strncmp(data+p,"SQ",2)==0 || strncmp(data+p,"SS",2)==0
      || strncmp(data+p,"ST",2)==0 || strncmp(data+p,"TM",2)==0
      || strncmp(data+p,"UI",2)==0 || strncmp(data+p,"UL",2)==0
      || strncmp(data+p,"UN",2)==0 || strncmp(data+p,"US",2)==0
      || strncmp(data+p,"UT",2)==0 )
    return 0;  //*****IȂ0Ԃ*****
  return -1;
}

//*****oCgXbv(short)*****/
unsigned short byte_swap(unsigned short in){
  unsigned short high,low;
  if(Endian()==0){
    high=low=in;
    return (high>>8) | (low<<8);
  }
  return in;
}
//*****oCgXbv(int)*****/
unsigned int byte_swap_int(unsigned int in){
  unsigned short high,low;

  if(Endian()==0){
    high=(in>>16);
    low =(in);
    return ( (byte_swap(low)<<16) | byte_swap(high) );
  }
  return in;
}


//ǂ
int LenRead(char *data,int *p){
  int len;
  char   vr[3];
 //********************************************
 //IVROB,OW,SQ,UN͓ȏꍇ
 //I()O[vvfVR(2oCg)(2byte)l(int)f[^
 //I()O[vvfVR(2oCg)l(short)f[^
 //ÖٓI      O[vvfl(int)f[^
 // ********************************************
  
  vr[2]='\0';
  if( VrCheck(data,*p)==0 ){   //*****I*****
    strncpy(vr,data+(*p),2); (*p)+=2;
    if(strstr(vr,"OB")!=NULL || strstr(vr,"OW")!=NULL	//*****Iȓ*****
       || strstr(vr,"SQ")!=NULL || strstr(vr,"UN")!=NULL){
      (*p)+=2;
      len= byte_swap_int( *(int *)(&data[*p]) );
      (*p)+=sizeof(int);
    }
    else{                        //*****IȈ*****
      len= byte_swap( *(short *)(&data[*p]) );
      (*p)+=sizeof(short);
    }
  }    
  else{                          //*****ÖٓI*****
    len= byte_swap_int( *(int *)(&data[*p]) );
    (*p)+=sizeof(int);
  }
  return len;
}


//DICOMwb_͂郁C
void DicomHeaderRead(char *filename,char *option){
  unsigned short group,element;
  unsigned int len;
  int i,p;  
  int f_size;
  char *data;
  char buffer[8];

  f_size=Filesize(filename);				//t@CTCY𒲂ׂ
  data=(char *)calloc(f_size,sizeof(char));		//m
  ReadFile(filename,data);				//t@Cǂ
  p=0;							//݂byteʒu=p
  p=DicomCheck(data,f_size);				//DICM܂ňړ
  while(p< f_size){											
    group= byte_swap( *(unsigned short *)&data[p] ); p+=2;	//O[vǂ
    element= byte_swap( *(unsigned short *)&data[p] ); p+=2;	//vfǂ
    printf("start=%5dbyte (0x%4.4o)\t (0x%4.4x:0x%4.4x) ",p-4,p-4,group,element);
    
    //
    //====> iV[PX̏ꍇ̂ݎgj====>
    //
    if(group==0xFFFE && element==0xE0DD ){			//V[PXI				
	printf("end Sequence\n",len);
  	p+=4; 
	continue; 
    }; 
    if(group==0xFFFE && element==0xE000 ){			//V[PX
      len= byte_swap_int( *(unsigned int *)(&data[p]) ); p+=4;
      printf("len=%d byte <==Sequence\t",len);
      if(len==0xffffffff)	continue;
      p+=len;
      continue;
    } 
    //
    // <====܂ŁiV[PX̏ꍇ̂ݎgj<====
    //
    len=LenRead(data,&p);					//f[^ǂ
    printf("len=%d byte\t",len);				
    if(len==0xffffffff)	continue;						
    
    //f[^\
    memcpy(buffer,data+p,8);	//8byte copy
    if( strcmp(option,"-x")==0){
	for(i=0;i<4;i++)
	    printf("%4.4X ", byte_swap( *(unsigned short *)&buffer[i*2] ));  
    }
    if( strcmp(option,"-c")==0){
	for(i=0;i<8;i++)
	    printf("%c ", buffer[i] );
    }
    if( strcmp(option,"-us")==0){
	for(i=0;i<4;i++)
	    printf("%d ", byte_swap( *(unsigned short *)&buffer[i*2] ) );
    }
    printf("\n");
    p+=len;							//ʒuړ
  }
  free(data);
}
