//all comments and codes by T. Hara

#include <stdio.h>
#include <stdlib.h>

#define USAGE "usage: templatematch  original-filename  width height reference-filename width height output-filename\n "

int i,j,ii,jj,width,height,header_size,ref_wid,ref_hei;
double ave_a, ave_b,*difference,tmp_diff,max;
unsigned char *reference,*org, *out;

void get_args(int argc, char **argv)
{
  if(argc != 8)
    {
      fprintf(stderr, USAGE);
      exit(1);
    }
  width = atoi(argv[2]); printf("W = %d,", width);
  height = atoi(argv[3]); printf("H = %d\n", height);

  ref_wid = atoi(argv[5]);printf("refW = %d,", width);
  ref_hei = atoi(argv[6]); printf("refH = %d\n", height);
}

void image_read_char(char *filename,int offset,unsigned char *im)
{
     FILE *fp;
     if ((fp=fopen(filename,"rb")) == NULL){
       printf("File Open Error Occured!\n");
       exit(-1);
     }
     fseek(fp,offset,0); 
     fread((unsigned char *)im,sizeof(char),width*height,fp);
     fclose(fp);
     printf("File Opening...: %s\n",filename);
}

void image_write_char(char *filename,
		      int w, int h,
		      unsigned char *im)
{
    FILE *fp;
    if ((fp=fopen(filename,"wb")) == NULL){
        printf("File Open Error Occured!\n");
        exit(-1);
    }
    fwrite((unsigned char *)im,sizeof(char), w * h, fp); fclose(fp);
}

int main(int argc, char **argv) 
{

  get_args(argc, argv);

  org = (unsigned char *)malloc(width*height*sizeof(char));
  reference = (unsigned char *)malloc(ref_wid*ref_hei*sizeof(char));

  difference = (double *)malloc(width*height*sizeof(double));

  out = (unsigned char *)malloc(width*height*sizeof(char));

  header_size=0;  

  image_read_char(argv[1],header_size,org);
  image_read_char(argv[4],header_size,reference);

  printf("Width = %d, height = %d \n",width,height);
  printf("Width = %d, height = %d \n",ref_wid,ref_hei);

  for(i=ref_hei/2;i<height-ref_hei/2;i++){
	for(j=ref_wid/2;j<width-ref_wid/2;j++){

		tmp_diff = 0.0;

		for(ii=0;ii<ref_hei;ii++){
			for(jj=0;jj<ref_wid;jj++){

			tmp_diff += 
			(org[(i+ii)*width+j+jj] -
			reference[ii*ref_wid + jj])*
			(org[(i+ii)*width+j+jj] -
			reference[ii*ref_wid + jj]);
			
			}
		}

		difference[i*width+j]=tmp_diff;

	}
}

  
  for(i=0;i<width*height;i++){
//	printf("%f,\n",difference[i]);
	if(max<=difference[i]){
		max=difference[i];
	}
}

        printf("the max value is %lf\n",max);

  for(i=0;i<width*height;i++){
	out[i] = (unsigned char)(difference[i]/max*255.0);
//	printf("%d,",out[i]);
}

  image_write_char(argv[7],width,height,out);

  return 0;
}
