//all comments and codes by T. Hara

#include <stdio.h>
#include <stdlib.h>

#define USAGE "usage: proc1 input-filename width height output-filename\n "

/***************
$B%3%s%Q%$%k$9$k$K$O(B
 gcc -o proc1 main.c  $B$HF~NO$7$F$/$@$5$$(B

$B<B9T$9$k$K$O(B,
 proc1 $BF~NO%U%!%$%kL>(B $B2hA|$NI}(B $B2hA|$N9b$5(B $B=PNO%U%!%$%kL>(B

$B$N=g$GF~NO$7$F$/$@$5$$(B

*****************/

int width,height,i,j,ii,jj,header_size;
unsigned char *image;

void get_args(int argc, char **argv)
{

//$B%3%^%s%I%i%$%s$N0z?t$N?t$N%A%'%C%/(B
  if(argc != 5)
    {
//      $B0z?t$N?t$,#58D$GL5$$>l9g$K$O(B,USAGE $B$rI=<($7$F=*N;(B
      fprintf(stderr, USAGE);
      exit(1);
    }

//$B2hA|$NI}$H9b$5$NFI$_9~$_(B
  width = atoi(argv[2]); printf("W = %d,", width);
  height = atoi(argv[3]); printf("H = %d,", height);
}

//$B%O!<%I%G%#%9%/$+$i$N2hA|%U%!%$%k$NFI$_9~$_(B
void image_read_char(char *filename,int offset,unsigned char *im)
//$B%U%!%$%kL>$H%X%C%@!<$N%P%$%H?t$rEO$9$3$H(B
{
//  $B%U%!%$%k%]%$%s%?$N@_Dj(B
     FILE *fp;

//$BFI$_<h$j@lMQ$G%U%!%$%k$r3+$/!#(B
     if ((fp=fopen(filename,"rb")) == NULL){

       //$B%(%i!<$N>l9g$O%a%C%;!<%8$rI=<($7$F=*N;(B
       printf("File Open Error Occured!\n");
       exit(-1);
     }

//$B%X%C%@!<$rFI$_Ht$P$9=hM}(B
     fseek(fp,offset,0);

//$B%U%!%$%k$rFI$_9~$`(B
     fread((char *)im,sizeof(char),width*height,fp);

//$BFI$_=*$o$C$?$i%U%!%$%k$rJD$8$F$*$/(B
     fclose(fp);

//$BFI$_9~$s$@%U%!%$%kL>$rI=<((B
     printf("File Opening...: %s\n",filename);
}

void image_write_char(char *filename,
		      int w, int h,
		      unsigned char *im)
{
    FILE *fp;
    
    if ((fp=fopen(filename,"wb")) == NULL){
        printf("File Open Error Occured!\n");
        exit(-1);
    }
    fwrite((char *)im,sizeof(char), w * h, fp);
    fclose(fp);
}


int main(int argc, char **argv) 
{

  /*$B2hA|$NI}$H9b$5$NFI$_9~$_(B*/
  get_args(argc, argv);

  /*$B2hA|$rJ]B8$9$kG[Ns!J%a%b%jNN0h!K$N=`Hw(B*/
  image = (char *)malloc(width*height*sizeof(char));
  
  /*$B2hA|%U%!%$%k$NFI$_9~$_(B*/
  header_size=0;
  image_read_char(argv[1],header_size,image);


  /***********
    $B$3$l$G2hA|%U%!%$%k$,G[Ns(B image $B$KJ]B8$5$l(B,
    $B$5$^$6$^$J7W;;$,$G$-$k$h$&$K$J$j$^$7$?!#(B
    **********/


  /*$B2hA|%U%!%$%k$NJ]B8(B*/
  image_write_char(argv[4],width,height,image);


  /*$B3NJ]$7$?G[Ns$N2rJ|(B $B!J$d$C$F$b$d$i$J$/$F$b$h$$!K(B*/
  free(image);

//$B=*N;;~$K$O#0$rJV$9(B
  return 0;
}
