//all comments and codes by T. Hara

#include <stdio.h>
#include <stdlib.h>

#define USAGE "usage: proc input-filename width height output-filename\n "

/***************
$B#C#A#D%;%_%J!<!?2hA|$N#2CM2=(B:$BCM$O<j$G$-$a$k(B

$B$3$N%W%m%0%i%`$r%3%s%Q%$%k$9$k$K$O(B
 gcc -o proc main.c  $B$HF~NO$7$F$/$@$5$$(B

$B<B9T$9$k$K$O(B,
 proc $BF~NO%U%!%$%kL>(B $B2hA|$NI}(B $B2hA|$N9b$5(B $B=PNO%U%!%$%kL>(B

$B$N=g$GF~NO$7$F$/$@$5$$(B

$B2hA|$r3+$-(B,$BG[Ns$KJ]B8$7$F!"#2CM2=$7$?7k2L$r=PNO%U%!%$%kL>$r$D$1$F(B
$B%O!<%I%G%#%9%/>e$KJ]B8$7$^$9!#(B

*****************/

//$BJQ?t$N@k8@(B

int width,height,header_size;
//width, height$B$O$=$l$>$l862hA|$NI}$H9b$5(B

unsigned char *inimg, *outimg;
//inimg$B$O862hA|$rJ]B8$9$kG[Ns!#(Boutimg$B$O=PNO2hA|$rJ]B8!#(B

void get_args(int argc, char **argv)
{
  if(argc != 5)
    {
      fprintf(stderr, USAGE);
      exit(1);
    }
  width = atoi(argv[2]); printf("W = %d,", width);
  height = atoi(argv[3]); printf("H = %d,", height);
}

void image_read_char(char *filename,int offset,unsigned char *im)
{
     FILE *fp;
     if ((fp=fopen(filename,"rb")) == NULL){
       printf("File Open Error Occured!\n");
       exit(-1);
     }
     fseek(fp,offset,0); fread((char *)im,sizeof(char),width*height,fp);
     fclose(fp);
     printf("File Opening...: %s\n",filename);
}

void image_write_char(char *filename,
		      int w, int h,
		      unsigned char *im)
{
    FILE *fp;
    if ((fp=fopen(filename,"wb")) == NULL){
        printf("File Open Error Occured!\n");
        exit(-1);
    }
    fwrite((char *)im,sizeof(char), w * h, fp); fclose(fp);
}

void binarize_image(unsigned char *org, unsigned char *out,
		    int w, int h, int threshold)
{
  int i,j;
  unsigned char max_value,min_value; 
  /*for$BJ8$N%k!<%WMQ(Bi,j$B$H:GBgCM$N@k8@(B*/
  /*$B#2CM2=$NCM$b$3$3$G;XDj$9$k!#(Bunsigned char$B$J$N$G!"(B
    $B:GBg(B255, $B:G>.(B0
    */

  max_value = 255;min_value = 0;
  printf("%d\n",threshold);

  for(i=0;i<h;i++){
    for(j=0;j<w;j++){
      
      if(org[i * w + j] >=threshold){
	out [i * w + j]=max_value;
      }
      else{
	out[i * w + j]=min_value;
      }
    }
  }
}

int main(int argc, char **argv) 
{
  int thresh;//$B#2CM2=MQ$NJQ?t(B

  /*$B2hA|$NI}$H9b$5$NFI$_9~$_(B*/
  get_args(argc, argv);

/*$B2hA|$rJ]B8$9$kG[Ns!J%a%b%jNN0h!K$N=`Hw(B*/
  inimg   = (char *)malloc(width*height*sizeof(char));
  outimg  = (char *)malloc(width*height*sizeof(char));

  /*$B2hA|%U%!%$%k$NFI$_9~$_(B*/
  header_size=0;  image_read_char(argv[1],header_size,inimg);

  printf("Input threshold = ");scanf("%d",&thresh);

  /* $B#2CM2==hM}$N4X?t$r8F$S!"$=$3$X#2$D$NG[Ns$HI}!"9b$5(B,$B$7$-$$CM$rEO$7$^$9!#(B*/
  binarize_image(inimg, outimg,width,height,thresh);

  /*$B2hA|%U%!%$%k$NJ]B8(B*/
  //$BJL$N%W%m%0%i%`$GI=<($7$F$_$F$/$@$5$$(B
  image_write_char(argv[4],width,height,outimg);

  free(outimg);free(inimg);
  return 0;
}
