//all comments and codes by T. Hara

#include <stdio.h>
#include <stdlib.h>

#define USAGE "usage: proc1 input-filename width height output-filename\n "

/***************
$B#C#A#D%;%_%J!<!?2hA|$NGr9uH?E>(B

$B%3%s%Q%$%k$9$k$K$O(B
 gcc -o proc2 main.c invert_by_mmx.c $B$HF~NO$7$F$/$@$5$$(B

$B<B9T$9$k$K$O(B,
 proc2 $BF~NO%U%!%$%kL>(B $B2hA|$NI}(B $B2hA|$N9b$5(B $B=PNO%U%!%$%kL>(B

$B$N=g$GF~NO$7$F$/$@$5$$(B

$B2hA|$r3+$-(B,$BG[Ns$KJ]B8$7$F!"Gr9uH?E>$7$?7k2L$r=PNO%U%!%$%kL>$r$D$1$F(B
$B%O!<%I%G%#%9%/>e$KJ]B8$7$^$9!#(B

$B$3$3$G!"$=$NJ}?K$H$7$F(B,

 $B862hA|$NJ]B8$5$l$?G[Ns(B
 $B=hM}7k2L$NJ]B8$5$l$?G[Ns(B

$B$rJL$KMQ0U$7$^$9!#(B

$B$^$?!"862hA|(B,$BGr9uH?E>2hA|$=$l$>$l$K$*$$$F!"(B
$B2hA|$N2hAGCM$NJ?6Q$r5a$a$F$_$^$9!#(B

$B!JCm(B:$B1i=,#1$H=E$J$k%3%a%s%H$O>iD9$J$?$a>C$7$F$"$j$^$9!K(B

*****************/
//$BJQ?t$N@k8@(B

int width,height,header_size;
//width, height$B$O$=$l$>$l862hA|$NI}$H9b$5(B

double ave_a, ave_b;
//$B2hAGCM$NJ?6Q$rJ]B8$9$kJQ?t!#(B

unsigned char *in, *inv_img;
//in$B$O862hA|$rJ]B8$9$kG[Ns!#(B inv_img$B$OH?E>2hA|$rJ]B8!#(B

void get_args(int argc, char **argv)
{
  if(argc != 5)
    {
      fprintf(stderr, USAGE);
      exit(1);
    }
  width = atoi(argv[2]); printf("W = %d,", width);
  height = atoi(argv[3]); printf("H = %d,", height);
}

void image_read_char(char *filename,int offset,unsigned char *im)
{
     FILE *fp;
     if ((fp=fopen(filename,"rb")) == NULL){
       printf("File Open Error Occured!\n");
       exit(-1);
     }
     fseek(fp,offset,0); fread((char *)im,sizeof(char),width*height,fp);
     fclose(fp);
     printf("File Opening...: %s\n",filename);
}

void image_write_char(char *filename,
		      int w, int h,
		      unsigned char *im)
{
    FILE *fp;
    if ((fp=fopen(filename,"wb")) == NULL){
        printf("File Open Error Occured!\n");
        exit(-1);
    }
    fwrite((char *)im,sizeof(char), w * h, fp); fclose(fp);
}


void invert_image(unsigned char *org, unsigned char *out,
		  int w, int h)
     /*$BGr9uH?E>$N2hA|$r$D$/$k4X?t!#(B
       $B$3$N4X?t$X$O!"#2$D$N2hA|(Borg, out$B$H$=$N>pJs!JI}$H9b$5!K$r(B
       $B0z?t$H$7$FEO$9!#(B
       $B$=$7$F!"(Borg$B2hA|$NH?E>2hA|$r(Bout$B$X:n@.$9$k!#(B
       $B7k2L2hA|$NJ]B8@h$bEO$5$l$F$$$k$3$H$KCm0U$7$F$/$@$5$$(B*/
{
  int i,j;
  unsigned char max_value; 
  /*for$BJ8$N%k!<%WMQ(Bi,j$B$H:GBgCM$N@k8@(B*/
  
  max_value = 255;
  /*$BGr9uH?E>$O:GBgCM$+$i2hAGCM$r0z$1$P$h$$$+$i!"(B
    $B:GBgCM$r@k8@$7$F$*$/(B*/


  /************ $B$3$3$,%]%$%s%H(B ***************/

  for(i=0;i<h;i++){
    for(j=0;j<w;j++){

      /* $B2hA|$NJ]B8$5$l$?G[Ns$K$O<!$N$h$&$K%"%/%;%9$9$k(B*/
      out[i * w + j] = max_value - org[i * w + j];

      /*$B$3$3$G!"(Bout[i * w + j]$B$,0UL#$9$k$b$N$O(B,
	$B#2<!85$N2hA|$,$9$Y$F#1Ns$K$D$J$,$C$F!"G[Ns$KJ]B8$5$l$F$$$k$?$a(B,
	$B#2<!85E*$K%"%/%;%9$9$k$?$a$K#2=E$N(Bfor$BJ8$r4:$($F:n$C$F$$$^$9!#(B

	$BJQ?t(Bi$B$O2hA|$N=DJ}8~$N0LCV$rI=$7(B,
	$BJQ?t(Bj$B$O2hA|$N2#J}8~$N0LCV$rI=$7$^$9!#(B

	(j, i)$B$H2hA|>e$N:BI8$H9M$($k$H$h$$$G$7$g$&!#(B

	$B$D$.$K!"$3$N2hA|$,$9$Y$F#1Ns$KJB$s$G$$$k$?$a(B,
	(j, i)$BHVCO$K%"%/%;%9$9$k$?$a$K$O!"@hF,$+$i2?8D$a$K$J$k$N$+$r(B
	$B?t$($kI,MW$,$"$j$^$9!#(B
	
	$B$7$?$,$C$F!"(B(j,i)$BHVCO$K$O(B,
	$B=D$,(Bi$B2s(B, $B2#$X(Bj $B%3%^$9$9$`$H9M$($k$H(B,

	i$B2s(B x $B2hA|$N2#I}(B $B!\(B j $B%3%^J,(B

	$B$H%"%/%;%9$9$k$HL\E*$N>l=j$N2hAGCM$,F@$i$l$k(B,
	$B$H$$$&$3$H$K$J$j$^$9!#(B*/


      /*$BCm(B:	$BC1$K2hA|$NH?E>$,L\E*$J$i(B

	for(i=0;i<h*w;i++)
	out[i]=255-org[i];

	$B$G$h$$$G$9!##2<!85E*$K%"%/%;%9$9$kI,MW$OA4$/$"$j$^$;$s(B	*/
	
      /************$B$3$3$^$G$,%]%$%s%H(B**************/
    }
  }
}

double get_average(unsigned char *in, int w, int h)
     /*$B2hA|$r(Bin$B$H$7$F<u$1(B,
       $B$=$NI}$H9b$5$,(Bw, h $B$H$7$F$=$l$>$l<u$1$k!#(B
       $B$^$?!"4X?t$N=PNO$H$7$FCM$r(Bdouble$B7?$GJV$9$N$G(B,
       $B@hF,$K(Bdouble$B$H$9$k!#(B*/
{
  /*$B$3$N4X?tFbItMQ$NJQ?t$r@k8@$7$^$9(B*/
  int i,pix_size;//i$B$O%k!<%WMQ!#(Bpix_size$B$O2hA|$NBg$-$5$N0l;~J]B8MQ(B
  double average;//$B2hAGCM$r<!!9$H2C;;$7$F$$$/NN0h!JJQ?t!K(B

  pix_size = w*h;
  /*$B:G=i$K2hA|$NBg$-$5$r7W;;$7$F$*$-$^$9(B
    $B%k!<%W$KF~$kA0$K7W;;$7$F$*$$$?J}$,(Bfor$BJ8$NI>2A$,Aa$/=*$j(B
    $B=hM}$N9bB.2=$K$D$J$,$k$H$5$l$F$$$^$9(B*/

  average = 0.0;
  //$B$3$3$XCM$,$I$s$I$sF~$C$F$/$k$?$a(B,$B:G=i$K#0$K=i4|2=$7$F$*$-$^$9(B

      //$B$"$H$O2hA|A4BN$r%k!<%W$GgS$a$^$9!#(B
  for(i=0;i<pix_size;i++){
    average += in[i];

    /*C$B8@8lFHFC$N=q$-J}$G$9!#(B
    average = in[i] + average;
    $B$3$N$h$&$J0UL#$,$"$j(B,$B?t3XE*$K$O4V0c$C$F$$$^$9$,(B,
    $B8E$$(Baverage$B$NCM$K(Bin[i]$B$r2C$($?CM$r?7$7$$(Baverage$B$H$7$F(B
    $BJ]B8$9$k$H$$$&0UL#$G$9!#(B
    
    $B87L)$K$O(B,
    $B#1!#8E$$CM$r0lEYBTHr$7$F(B,
    $B#2!#?7$7$$CM$r2C;;$7$F(B
    $B#3!#85$"$C$?>l=j$K$b$I$9(B
    $B$H$$$&#3CJ3,$N=hM}$+$i$J$j$^$9$,!"$=$l$r#1%9%F%C%W$G=hM}$G$-$^$9!#(B
    */
  }
  return(average/(double)pix_size);
}  

int main(int argc, char **argv) 
{

  /*$B2hA|$NI}$H9b$5$NFI$_9~$_(B*/
  get_args(argc, argv);

  /*$B2hA|$rJ]B8$9$kG[Ns!J%a%b%jNN0h!K$N=`Hw(B*/
// in $B$K$O862hA|$rF~$l$^$9!#(Brev_img$B$K$OH?E>2hA|$rF~$l$^$9!#(B
// $BBg$-$5$O$$$C$7$g$J$N$GF1$8Bg$-$5$G3NJ]$7$^$9!#(B
  in      = (char *)malloc(width*height*sizeof(char));
  inv_img = (char *)malloc(width*height*sizeof(char));

  /*$B2hA|%U%!%$%k$NFI$_9~$_(B*/
  header_size=0;  image_read_char(argv[1],header_size,in);

  /* $BGr9uH?E>=hM}$N4X?t$r8F$S!"$=$3$X#2$D$NG[Ns$HI}!"9b$5$rEO$7$^$9!#(B*/
//  invert_image(in, inv_img,width,height);

/*$B$$$s$F$k$W$m$;$C$5$K$H$&$5$$$5$l$F$$$k(BMMX$B$F$/$N$m$8$r(B
$B$j$h$&$7$F(B,$B$-$C$H$3$&$=$/$J$7$g$j$r$9$k$O$s$F$s$7$g$j(B*/

invert_by_mmx_uchar(in, inv_img,width,height);
   
  /*$B<!$K2hA|$N2hAGCM$NJ?6Q$r5a$a$^$7$g$&!#(B
    $B$3$3$G!"#2$D$N2hA|$=$l$>$lMQ$K4X?t$r$D$/$C$F$bNI$$$G$9$,(B,
    $BF1$8L\E*$J$i(B,$BHFMQ@-$N$"$k#1$D$N4X?t$r$D$/$C$F$=$l$rMxMQ$7$^$7$g$&(B.
    $B862hA|$NJ?6Q$O(Bave_a,$BH?E>2hA|$NJ?6Q$O(Bave_b$B$KJ]B8$9$k$3$H$H$7$^$9(B*/

  ave_a = get_average(in,width,height);
  ave_b = get_average(inv_img,width,height);

  /*$B$3$l$GCM$,$=$l$>$l$NJQ?t$KF~NO$5$l$^$7$?!#(B
    $B$D$.$O$=$l$i#2$D$NCM$rI=<($7(B,
    $B$^$?!"#2$D$NCM$rB-$7$?7k2L$rI=<($7$F$_$^$9!#(B*/


  /*$B$^$:#2$D$NCM$NI=<($O(Bprintf$BJ8$G$G$-$^$9(B*/
  printf("Average pixel value of input image is %f\n",ave_a);
  printf("Average pixel value of invert image is %f\n",ave_b);

  /*$BI=<($9$kCM$NItJ,$K$O7W;;<0$r=q$$$F$b$h$$$G$7$g$&(B.
    $B$3$3$G$O!"H?E>$7$?2hA|$NJ?6Q$H852hA|$NJ?6Q$J$N$G!"(B
    $B$=$N#2$D$NOB$O(B255$B$K$J$k$O$:$G$9!J$h$M!)!K!#(B*/
  printf("Sum of those two value is %f\n",ave_a+ave_b);

//$B$"$H$OF1$8!#(B

  /*$B2hA|%U%!%$%k!JH?E>2hA|!K$NJ]B8(B*/
//$BJL$N%W%m%0%i%`$GI=<($7$F$_$F$/$@$5$$(B
//  image_write_char(argv[4],width,height,inv_img);

  /*$B3NJ]$7$?G[Ns$N2rJ|(B $B!J$d$C$F$b$d$i$J$/$F$b$h$$!K(B*/
  free(inv_img);free(in);

//$B=*N;;~$K$O#0$rJV$9(B
  return 0;
}
