//all comments and codes by T. Hara

#include <stdio.h>
#include <stdlib.h>

#define USAGE "usage: proc input-filename width height output-filename\n "

/***************
$B#C#A#D%;%_%J!<!?2hA|$N3,D4JQ49(B(3)

$B:#EY$O(B,CT$B2hA|$G$d$C$F$_$^$7$g$&!#(B
CT$B2hA|$OIi$NCM$,F~$k$?$a(B,short$B7?$G$9!#(B

$B%3%s%Q%$%k$K$O(B

make

$B$N(B1$B%o!<%I$G$9!#(B

*****************/

//$BJQ?t$N@k8@(B

int width,height,header_size;
//width, height$B$O$=$l$>$l862hA|$NI}$H9b$5(B

double ave_a, ave_b;
//$B2hAGCM$NJ?6Q$rJ]B8$9$kJQ?t!#(B

short *in;//$BF~NOMQ$O(Bshort$B7?(B
unsigned char *out;//$B=PNOMQ$O(Bchar$B7?(B

void get_args(int argc, char **argv)
{
  if(argc != 5)
    {
      fprintf(stderr, USAGE);
      exit(1);
    }
  width = atoi(argv[2]); printf("W = %d,", width);
  height = atoi(argv[3]); printf("H = %d,", height);
}

void image_read_short(char *filename,int offset,short *im)
{
     FILE *fp;
     if ((fp=fopen(filename,"rb")) == NULL){
       printf("File Open Error Occured!\n");
       exit(-1);
     }
     fseek(fp,offset,0); 
     fread((short *)im,sizeof(short),width*height,fp);
     fclose(fp);
     printf("File Opening...: %s\n",filename);
}

void image_write_char(char *filename,
		      int w, int h,
		      unsigned char *im)
{
    FILE *fp;
    if ((fp=fopen(filename,"wb")) == NULL){
        printf("File Open Error Occured!\n");
        exit(-1);
    }
    fwrite((unsigned char *)im,sizeof(char), w * h, fp); fclose(fp);
}

double get_average_short(short *in, int w, int h)
{
  int i,pix_size;//i$B$O%k!<%WMQ!#(Bpix_size$B$O2hA|$NBg$-$5$N0l;~J]B8MQ(B
  double average;//$B2hAGCM$r<!!9$H2C;;$7$F$$$/NN0h!JJQ?t!K(B

  pix_size = w*h;  average = 0.0;  //$B=i4|2=$7$F$*$-$^$9(B

  for(i=0;i<pix_size;i++){
    average += in[i];
  }
  return(average/(double)pix_size);
}

int main(int argc, char **argv) 
{

  /*$B2hA|$NI}$H9b$5$NFI$_9~$_(B*/
  get_args(argc, argv);

  /*$B2hA|$rJ]B8$9$kG[Ns!J%a%b%jNN0h!K$N=`Hw(B*/
// in $B$K$O862hA|$rF~$l$^$9!#(Bout$B$K$O=PNO2hA|$rF~$l$^$9!#(B
// $BBg$-$5$O$$$C$7$g$J$N$GF1$8Bg$-$5$G3NJ]$7$^$9!#(B
  in  = malloc(width*height*sizeof(short));
  out = malloc(width*height*sizeof(char));

  /*$B2hA|%U%!%$%k$NFI$_9~$_(B*/
  header_size=0;  image_read_short(argv[1],header_size,in);

//  printf("Width = %d, height = %d \n",width,height);

  ave_a = get_average_short(in, width, height);
  printf("Average pixel value of input image is %f\n",ave_a);

  /*
$BB?%P%$%HD9$N%G!<%?$K$J$k$H(B,$B@h$K=P$F$/$k%P%$%HNs$,Bg$-$$$N$+(B,
$B:G8e$K=P$F$/$k%P%$%HNs$,B?$-$N$+$,LdBj$K$J$j$^$9!#(B
*/

  byte_swap_short(in,width,height);

  ave_a = get_average_short(in,  width, height);
  printf("Average pixel value of input image is %f\n",ave_a);

  /* $B3,D4=hM}$N4X?t$r8F$S!"$=$3$X#2$D$NG[Ns$HI}!"9b$5$rEO$7$^$9!#(B*/
  win_proc_short(in,out, width, height);
     
  /*$B2hA|%U%!%$%k$NJ]B8(B*/
//$BJL$N%W%m%0%i%`$GI=<($7$F$_$F$/$@$5$$(B
  image_write_char(argv[4],width,height,out);

  /*$B3NJ]$7$?G[Ns$N2rJ|(B $B!J$d$C$F$b$d$i$J$/$F$b$h$$!K(B*/
  free(out);free(in);

//$B=*N;;~$K$O#0$rJV$9(B
  return 0;
}
