//all comments and codes by T. Hara

#include <stdio.h>
#include <stdlib.h>

#define USAGE "usage: proc input-filename width height output-filename\n "

/***************
$B#C#A#D%;%_%J!<!?2hA|$N3,D4JQ49(B

$B%3%s%Q%$%k$9$k$K$O(B
 gcc -o proc main.c winproc.c $B$HF~NO$7$F$/$@$5$$(B

$B$$$D$^$G$b(Bmain.c$B$N%U%!%$%k$NCf$K4X?t$r=q$$$F$$$/$H(B
$BHs>o$KD9$/$J$j8+$K$/$/$J$k$?$a$G$9!#(B

$BE,EY$K%U%!%$%k$rJ,3d$7$F4IM}$7$?J}$,$h$$$G$9!#(B

$B<B9T$9$k$K$O(B,
 proc $BF~NO%U%!%$%kL>(B $B2hA|$NI}(B $B2hA|$N9b$5(B $B=PNO%U%!%$%kL>(B

$B$N=g$GF~NO$7$F$/$@$5$$(B

$BGr9uH?E>=hM}$HF1MM$K(B,$B=hM}8e$N2hA|$r=PNO%U%!%$%kL>$GEO$7$^$9(B

$B!JCm(B:$B1i=,#1(B,$B#2$H=E$J$k%3%a%s%H$O>iD9$J$?$a>C$7$F$"$j$^$9!K(B

*****************/

//$BJQ?t$N@k8@(B

int width,height,header_size;
//width, height$B$O$=$l$>$l862hA|$NI}$H9b$5(B

double ave_a, ave_b;
//$B2hAGCM$NJ?6Q$rJ]B8$9$kJQ?t!#(B

unsigned char *in, *out;
//in$B$O862hA|$rJ]B8$9$kG[Ns!#(B out$B$OH?E>2hA|$rJ]B8!#(B
//$B#C8@8l$G$O<B$OG[Ns$H%]%$%s%?$H$OJL!#(B
//$B$=$N5DO@$O$3$3$G$O9T$$$^$;$s!#(B
//$B$3$N%;%_%J$N$h$&$K;H$&$H%]%$%s%?$,G[Ns$N$h$&$K;H$($^$9(B

void get_args(int argc, char **argv)
{
  if(argc != 5)
    {
      fprintf(stderr, USAGE);
      exit(1);
    }
  width = atoi(argv[2]); printf("W = %d,", width);
  height = atoi(argv[3]); printf("H = %d,", height);
}

void image_read_char(char *filename,int offset,unsigned char *im)
{
     FILE *fp;
     if ((fp=fopen(filename,"rb")) == NULL){
       printf("File Open Error Occured!\n");
       exit(-1);
     }
     fseek(fp,offset,0); 
     fread((unsigned char *)im,sizeof(char),width*height,fp);
     fclose(fp);
     printf("File Opening...: %s\n",filename);
}

void image_write_char(char *filename,
		      int w, int h,
		      unsigned char *im)
{
    FILE *fp;
    if ((fp=fopen(filename,"wb")) == NULL){
        printf("File Open Error Occured!\n");
        exit(-1);
    }
    fwrite((unsigned char *)im,sizeof(char), w * h, fp); fclose(fp);
}

double get_average(unsigned char *in, int w, int h)
{
  int i,pix_size;//i$B$O%k!<%WMQ!#(Bpix_size$B$O2hA|$NBg$-$5$N0l;~J]B8MQ(B
  double average;//$B2hAGCM$r<!!9$H2C;;$7$F$$$/NN0h!JJQ?t!K(B

  pix_size = w*h;
  average = 0.0;  //$B=i4|2=$7$F$*$-$^$9(B

  for(i=0;i<pix_size;i++){
    average += in[i];
  }
  return(average/(double)pix_size);
}

int main(int argc, char **argv) 
{

  /*$B2hA|$NI}$H9b$5$NFI$_9~$_(B*/
  get_args(argc, argv);

  /*$B2hA|$rJ]B8$9$kG[Ns!J%a%b%jNN0h!K$N=`Hw(B*/
// in $B$K$O862hA|$rF~$l$^$9!#(Bout$B$K$O=PNO2hA|$rF~$l$^$9!#(B
// $BBg$-$5$O$$$C$7$g$J$N$GF1$8Bg$-$5$G3NJ]$7$^$9!#(B
  in  = (char *)malloc(width*height*sizeof(char));
  out = (char *)malloc(width*height*sizeof(char));

  /*$B2hA|%U%!%$%k$NFI$_9~$_(B*/
  header_size=0;  image_read_char(argv[1],header_size,in);

//  printf("Width = %d, height = %d \n",width,height);

  /* $B3,D4=hM}$N4X?t$r8F$S!"$=$3$X#2$D$NG[Ns$HI}!"9b$5$rEO$7$^$9!#(B*/
  win_proc(in,out, width, height);
     
  /*$B<!$K2hA|$N2hAGCM$NJ?6Q$r5a$a$^$7$g$&!#(B
    $B$3$3$G!"#2$D$N2hA|$=$l$>$lMQ$K4X?t$r$D$/$C$F$bNI$$$G$9$,(B,
    $BF1$8L\E*$J$i(B,$BHFMQ@-$N$"$k#1$D$N4X?t$r$D$/$C$F$=$l$rMxMQ$7$^$7$g$&(B.
    $B862hA|$NJ?6Q$O(Bave_a,$BH?E>2hA|$NJ?6Q$O(Bave_b$B$KJ]B8$9$k$3$H$H$7$^$9(B*/

  ave_a = get_average(in,  width, height);
  ave_b = get_average(out, width, height);

  /*$B$3$l$GCM$,$=$l$>$l$NJQ?t$KF~NO$5$l$^$7$?!#(B
    $B$D$.$O$=$l$i#2$D$NCM$rI=<($7(B,
    $B$^$?!"#2$D$NCM$rB-$7$?7k2L$rI=<($7$F$_$^$9!#(B*/


  /*$B#2$D$NCM$NI=<($O(Bprintf$BJ8$G$G$-$^$9(B*/
  printf("Average pixel value of input image is %f\n",ave_a);
  printf("Average pixel value of invert image is %f\n",ave_b);

  /*$B2hA|%U%!%$%k$NJ]B8(B*/
//$BJL$N%W%m%0%i%`$GI=<($7$F$_$F$/$@$5$$(B
  image_write_char(argv[4],width,height,out);

  /*$B3NJ]$7$?G[Ns$N2rJ|(B $B!J$d$C$F$b$d$i$J$/$F$b$h$$!K(B*/
  free(out);free(in);

//$B=*N;;~$K$O#0$rJV$9(B
  return 0;
}
