void convolve_laplace(unsigned char *in, unsigned char *out,
		      int wid, int hei)
{

  int i,j;
//  double tmp,conv[3][3]={{1.0, 1.0, 1.0},{1.0, 1.0, 1.0},{1.0, 1.0, 1.0}};
  double tmp,conv[3][3]={{-1.0, -1.0,-1.0},{-1.0, 9.0, -1.0},{-1.0, -1.0, -1.0}};

  for(j=1;j<hei-1;j++){
    for(i=1;i<wid-1;i++){

      tmp =
	(double)in[(j-1)*wid+(i-1)]*conv[0][0]+
	(double)in[(j-1)*wid+i    ]*conv[0][1]+
	(double)in[(j-1)*wid+(i+1)]*conv[0][2]+

	(double)in[j  *wid+(i-1)]*conv[1][0]+
	(double)in[j  *wid+i    ]*conv[1][1]+
	(double)in[j  *wid+(i+1)]*conv[1][2]+

	(double)in[(j+1)*wid+(i-1)]*conv[2][0]+
	(double)in[(j+1)*wid+i    ]*conv[2][1]+
	(double)in[(j+1)*wid+(i+1)]*conv[2][2];

      if(tmp>255){
	out[j*wid+i]=255.0;
      }
      else if(tmp<0){
	out[j*wid+i] = 0.0;
      }
      else {
	out[j*wid+i] = (unsigned char)tmp;
      }
    }
  }
}

void convolve_smooth(unsigned char *in, unsigned char *out,
	      int wid, int hei)
{

  int i,j;
  double tmp,conv[3][3]={{1.0, 1.0, 1.0},{1.0, 1.0, 1.0},{1.0, 1.0, 1.0}};

//  conv[3][3] = {{1.0, 0.0, -1.0},{1.0, 0.0, -1.0},{1.0, 0.0, -1.0}};


  for(j=1;j<hei-1;j++){
    for(i=1;i<wid-1;i++){

      tmp =
	in[(j-1)*wid+(i-1)]*conv[0][0]+
	in[(j-1)*wid+i    ]*conv[0][1]+
	in[(j-1)*wid+(i+1)]*conv[0][2]+

	in[j  *wid+(i-1)]*conv[1][0]+
	in[j  *wid+i    ]*conv[1][1]+
	in[j  *wid+(i+1)]*conv[1][2]+

	in[(j+1)*wid+(i-1)]*conv[2][0]+
	in[(j+1)*wid+i    ]*conv[2][1]+
	in[(j+1)*wid+(i+1)]*conv[2][2];

      tmp /= 9.0;

      out[j*wid+i] = (unsigned char)tmp;
    }
  }
}  
