//all comments and codes by T. Hara

#include <stdio.h>
#include <stdlib.h>

#define USAGE "usage: proc input-filename width height output-filename\n "

/***************
$B#C#A#D%;%_%J!<!?2hA|$N#2CM2=(B

$B#2CM2=$H$O!"2hA|$rGr9u$N#2$D$NCM!J#2CM!K$KJQ49$9$k=hM}$G$9!#(B
$BGr(B,$B9u$r#0$H#2#5#5$J$I$GI=$7$^$9!#(B


$B$3$N%W%m%0%i%`$r%3%s%Q%$%k$9$k$K$O(B
 gcc -o proc main.c  $B$HF~NO$7$F$/$@$5$$(B

$B<B9T$9$k$K$O(B,
 proc $BF~NO%U%!%$%kL>(B $B2hA|$NI}(B $B2hA|$N9b$5(B $B=PNO%U%!%$%kL>(B

$B$N=g$GF~NO$7$F$/$@$5$$(B

$B2hA|$r3+$-(B,$BG[Ns$KJ]B8$7$F!"#2CM2=$7$?7k2L$r=PNO%U%!%$%kL>$r$D$1$F(B
$B%O!<%I%G%#%9%/>e$KJ]B8$7$^$9!#(B

$B$^$:!"2hA|$NJ?6QCM$G#2CM2=$7$F$_$^$7$g$&!#(B

$B<j=g$O!"(B
$B#1!'2hA|$NG[Ns$X$NJ]B8(B
$B#2!'2hA|$NJ?6QCM$N;;=P(B
$B#3!'#2CM2=$N<B9T(B
$B#4!'7k2L2hA|$NJ]B8(B
$B$K$J$j$^$9!#(B
*****************/

//$BJQ?t$N@k8@(B

int width,height,header_size;
//width, height$B$O$=$l$>$l862hA|$NI}$H9b$5(B

double ave_a;
//$B2hAGCM$NJ?6Q$rJ]B8$9$kJQ?t!#(B

unsigned char *inimg, *outimg;
//inimg$B$O862hA|$rJ]B8$9$kG[Ns!#(Boutimg$B$O=PNO2hA|$rJ]B8!#(B

void get_args(int argc, char **argv)
{
  if(argc != 5)
    {
      fprintf(stderr, USAGE);
      exit(1);
    }
  width = atoi(argv[2]); printf("W = %d,", width);
  height = atoi(argv[3]); printf("H = %d,", height);
}

void image_read_char(char *filename,int offset,unsigned char *im)
{
     FILE *fp;
     if ((fp=fopen(filename,"rb")) == NULL){
       printf("File Open Error Occured!\n");
       exit(-1);
     }
     fseek(fp,offset,0); fread((char *)im,sizeof(char),width*height,fp);
     fclose(fp);
     printf("File Opening...: %s\n",filename);
}

void image_write_char(char *filename,
		      int w, int h,
		      unsigned char *im)
{
    FILE *fp;
    if ((fp=fopen(filename,"wb")) == NULL){
        printf("File Open Error Occured!\n");
        exit(-1);
    }
    fwrite((char *)im,sizeof(char), w * h, fp); fclose(fp);
}

void binarize_image(unsigned char *org, unsigned char *out,
		    int w, int h, int threshold)
     /*$B#2CM$N2hA|$r$D$/$k4X?t!#(B
       $B$3$N4X?t$X$O!"#2$D$N2hA|(Borg, out$B$H$=$N>pJs!JI}$H9b$5!K$r(B
       $B0z?t$H$7$FEO$9!#(B
       $B$=$7$F!"(Borg$B2hA|$N#2CM2hA|$r(Bout$B$X:n@.$9$k!#(B
       $B7k2L2hA|$NJ]B8@h$bEO$5$l$F$$$k$3$H$KCm0U$7$F$/$@$5$$(B
       
       $B$^$?!"J}?K$H$7$F!"J?6QCM$G#2CM2=$9$k$3$H$r5a$a$:$K(B,
       $B#2CM2=$NCM$b4X?t$KEO$9$3$H$K$h$C$F(B,
       $B;H$$2s$9$3$H$r9M$($k!#(B

       $B$D$^$j!"J?6QCM$G#2CM2=$J$N$G!"(B
         $BJ?6Q$r5a$a(B, $B$=$NCM$G#2CM2=(B
	 $B$H#2CJ2s$G9M$($k!#(B
       */
{
  int i,j;
  unsigned char max_value,min_value; 
  /*for$BJ8$N%k!<%WMQ(Bi,j$B$H:GBgCM$N@k8@(B*/


  /*$B#2CM2=$NCM$b$3$3$G;XDj$9$k!#(Bunsigned char$B$J$N$G!"(B
    $B:GBg(B255, $B:G>.(B0
    */

  max_value = 255;min_value = 0;

  printf("%d\n",threshold);

  /************ $B$3$3$,%]%$%s%H(B ***************/

  for(i=0;i<h;i++){
    for(j=0;j<w;j++){

      /* $B2hA|$NJ]B8$5$l$?G[Ns$K$O<!$N$h$&$K%"%/%;%9$9$k(B
	 $B$=$7$F!"CM$,(Bthreshold$B$h$j$bBg$-$1$l$P(Bout$B$r(B255$B$K(B
	 $B>.$5$1$l$P(Bout$B$r(B0$B$K$9$k!#(B
       */
      
      if(org[i * w + j] >=threshold){
	out [i * w + j]=max_value;
      }
      else{
	out[i * w + j]=min_value;
      }
      /*$B$3$3$G!"(Bout[i * w + j]$B$,0UL#$9$k$b$N$O(B,
	$B#2<!85$N2hA|$,$9$Y$F#1Ns$K$D$J$,$C$F!"G[Ns$KJ]B8$5$l$F$$$k$?$a(B,
	$B#2<!85E*$K%"%/%;%9$9$k$?$a$K#2=E$N(Bfor$BJ8$r4:$($F:n$C$F$$$^$9!#(B

	$BJQ?t(Bi$B$O2hA|$N=DJ}8~$N0LCV$rI=$7(B,
	$BJQ?t(Bj$B$O2hA|$N2#J}8~$N0LCV$rI=$7$^$9!#(B

	(j, i)$B$H2hA|>e$N:BI8$H9M$($k$H$h$$$G$7$g$&!#(B

	$B$D$.$K!"$3$N2hA|$,$9$Y$F#1Ns$KJB$s$G$$$k$?$a(B,
	(j, i)$BHVCO$K%"%/%;%9$9$k$?$a$K$O!"@hF,$+$i2?8D$a$K$J$k$N$+$r(B
	$B?t$($kI,MW$,$"$j$^$9!#(B
	
	$B$7$?$,$C$F!"(B(j,i)$BHVCO$K$O(B,
	$B=D$,(Bi$B2s(B, $B2#$X(Bj $B%3%^$9$9$`$H9M$($k$H(B,

	i$B2s(B x $B2hA|$N2#I}(B $B!\(B j $B%3%^J,(B

	$B$H%"%/%;%9$9$k$HL\E*$N>l=j$N2hAGCM$,F@$i$l$k(B,
	$B$H$$$&$3$H$K$J$j$^$9!#(B*/


      /*$BCm(B:$B$"$($F#2<!85$G9T$$$^$7$?$,(B,
	$BK\Ev$K4JC1$K$9$k$K$O!"A4It$J$a$F$$$1$P$$$$$N$G!"(B

	for(i=0;i<h*w;i++){
	if(org[i]>>threshold)
	{
	    out[i]=max_value;
	    }
	else{
	    out[i]=min_value;
	}

	$B$G$h$$$G$9!##2<!85E*$K%"%/%;%9$9$kI,MW$OA4$/$"$j$^$;$s(B	*/
	
      /************$B$3$3$^$G$,%]%$%s%H(B**************/
    }
  }
}

double get_average(unsigned char *in, int w, int h)
     /*$B2hA|$r(Bin$B$H$7$F<u$1(B,
       $B$=$NI}$H9b$5$,(Bw, h $B$H$7$F$=$l$>$l<u$1$k!#(B
       $B$^$?!"4X?t$N=PNO$H$7$FCM$r(Bdouble$B7?$GJV$9$N$G(B,
       $B@hF,$K(Bdouble$B$H$9$k!#(B*/
{
  /*$B$3$N4X?tFbItMQ$NJQ?t$r@k8@$7$^$9(B*/
  int i,pix_size;//i$B$O%k!<%WMQ!#(Bpix_size$B$O2hA|$NBg$-$5$N0l;~J]B8MQ(B
  double average;//$B2hAGCM$r<!!9$H2C;;$7$F$$$/NN0h!JJQ?t!K(B

  pix_size = w*h;
  /*$B:G=i$K2hA|$NBg$-$5$r7W;;$7$F$*$-$^$9(B
    $B%k!<%W$KF~$kA0$K7W;;$7$F$*$$$?J}$,(Bfor$BJ8$NI>2A$,Aa$/=*$j(B
    $B=hM}$N9bB.2=$K$D$J$,$k$H$5$l$F$$$^$9(B*/

  average = 0.0;
  //$B$3$3$XCM$,$I$s$I$sF~$C$F$/$k$?$a(B,$B:G=i$K#0$K=i4|2=$7$F$*$-$^$9(B

      //$B$"$H$O2hA|A4BN$r%k!<%W$GgS$a$^$9!#(B
  for(i=0;i<pix_size;i++){
    average += in[i];

    /*C$B8@8lFHFC$N=q$-J}$G$9!#(B
    average = in[i] + average;
    $B$3$N$h$&$J0UL#$,$"$j(B,$B?t3XE*$K$O4V0c$C$F$$$^$9$,(B,
    $B8E$$(Baverage$B$NCM$K(Bin[i]$B$r2C$($?CM$r?7$7$$(Baverage$B$H$7$F(B
    $BJ]B8$9$k$H$$$&0UL#$G$9!#(B
    
    $B87L)$K$O(B,
    $B#1!#8E$$CM$r0lEYBTHr$7$F(B,
    $B#2!#?7$7$$CM$r2C;;$7$F(B
    $B#3!#85$"$C$?>l=j$K$b$I$9(B
    $B$H$$$&#3CJ3,$N=hM}$+$i$J$j$^$9$,!"$=$l$r#1%9%F%C%W$G=hM}$G$-$^$9!#(B
    */
  }
  return(average/(double)pix_size);
}  

int main(int argc, char **argv) 
{
  /*$B2hA|$NI}$H9b$5$NFI$_9~$_(B*/
  get_args(argc, argv);

/*$B2hA|$rJ]B8$9$kG[Ns!J%a%b%jNN0h!K$N=`Hw(B*/
// in $B$K$O862hA|$rF~$l$^$9!#(Brev_img$B$K$OH?E>2hA|$rF~$l$^$9!#(B
// $BBg$-$5$O$$$C$7$g$J$N$GF1$8Bg$-$5$G3NJ]$7$^$9!#(B
  inimg   = (char *)malloc(width*height*sizeof(char));
  outimg  = (char *)malloc(width*height*sizeof(char));

  /*$B2hA|%U%!%$%k$NFI$_9~$_(B*/
  header_size=0;  image_read_char(argv[1],header_size,inimg);
     
  /*$B$^$:2hA|$N2hAGCM$NJ?6Q$r5a$a$^$7$g$&!#(B
    $BF1$8L\E*$J$i(B,$BHFMQ@-$N$"$k#1$D$N4X?t$r$D$/$C$F$=$l$rMxMQ$7$^$7$g$&(B.
    $B862hA|$NJ?6Q$O(Bave_a********/

  ave_a = get_average(inimg,width,height);

  /*$B$3$l$GCM$,JQ?t$KF~NO$5$l$^$7$?!#(B
    $B$D$.$OCM$rI=<($7$F$_$^$9!#(B*/

  /*$BCM$NI=<($O(Bprintf$BJ8$G$G$-$^$9(B*/
  printf("Average pixel value of input image is %f\n",ave_a);


  /* $B#2CM2==hM}$N4X?t$r8F$S!"$=$3$X#2$D$NG[Ns$HI}!"9b$5(B,$B$7$-$$CM$rEO$7$^$9!#(B*/
  binarize_image(inimg, outimg,width,height,(int)ave_a);


  /*$B2hA|%U%!%$%k$NJ]B8(B*/
  //$BJL$N%W%m%0%i%`$GI=<($7$F$_$F$/$@$5$$(B

  image_write_char(argv[4],width,height,outimg);

  /*$B3NJ]$7$?G[Ns$N2rJ|(B $B!J$d$C$F$b$d$i$J$/$F$b$h$$!K(B*/
  free(outimg);free(inimg);

//$B=*N;;~$K$O#0$rJV$9(B
  return 0;
}
