//all comments and codes by T. Hara

#include <stdio.h>
#include <stdlib.h>

#define USAGE "usage: proc input-filename width height output-filename\n "


/***************
$B#C#A#D%;%_%J!<!?#2CM2hA|$NKDD%!?<}=L=hM}(B

$B$3$N1i=,$G$O(B,$B#2CM2hA|$N<}=L=hM}$K$D$$$F<h$j07$$$^$9!#(B

$B$3$N%W%m%0%i%`$r%3%s%Q%$%k$9$k$K$O(B
 gcc -o proc main.c  $B$HF~NO$7$F$/$@$5$$(B

$B<B9T$9$k$K$O(B,
 proc $BF~NO%U%!%$%kL>(B $B2hA|$NI}(B $B2hA|$N9b$5(B $B=PNO%U%!%$%kL>(B

$B$N=g$GF~NO$7$F$/$@$5$$(B

$B2hA|$r3+$-(B,$BG[Ns$KJ]B8$7$F!"=hM}$7$?7k2L$r=PNO%U%!%$%kL>$r$D$1$F(B
$B%O!<%I%G%#%9%/>e$KJ]B8$7$^$9!#(B

$BJ}?K(B:
$B#2CM2=$O2hA|$NJ?6QCM$G9T$&!#(B
$BGr$$NN0h$,>.$5$/$J$k$h$&$K$9$k!#(B

$B<j=g$O!"(B
$B#1!'2hA|$NG[Ns$X$NJ]B8(B
$B#2!'#2CM2=$N<B9T(B
$B#3!'Gr$$NN0h$N<}=L=hM}(B
$B#4!'7k2L2hA|$NJ]B8(B

$B$K$J$j$^$9!#(B
*****************/

//$BJQ?t$N@k8@(B

int width,height,header_size;
//width, height$B$O$=$l$>$l862hA|$NI}$H9b$5(B

unsigned char *inimg, *outimg;
//inimg$B$O862hA|$rJ]B8$9$kG[Ns!#(Boutimg$B$O=PNO2hA|$rJ]B8!#(B

void get_args(int argc, char **argv)
{
  if(argc != 5)
    {
      fprintf(stderr, USAGE);
      exit(1);
    }
  width = atoi(argv[2]); printf("W = %d,", width);
  height = atoi(argv[3]); printf("H = %d,", height);
}

void image_read_char(char *filename,int offset,unsigned char *im)
{
     FILE *fp;
     if ((fp=fopen(filename,"rb")) == NULL){
       printf("File Open Error Occured!\n");
       exit(-1);
     }
     fseek(fp,offset,0); fread((char *)im,sizeof(char),width*height,fp);
     fclose(fp);
     printf("File Opening...: %s\n",filename);
}

void image_write_char(char *filename,
		      int w, int h,
		      unsigned char *im)
{
    FILE *fp;
    if ((fp=fopen(filename,"wb")) == NULL){
        printf("File Open Error Occured!\n");
        exit(-1);
    }
    fwrite((char *)im,sizeof(char), w * h, fp); fclose(fp);
}

void erosion(unsigned char *org, unsigned char *out,
	     int w,int h)
     /*$B<}=L=hM}$O(B,$B%b%k%U%)%m%8=hM}$G$O(Berosion$B=hM}$H$h$V!#(B
       $B$3$N4X?t$X$O!"#2$D$N2hA|(Borg, out$B$H$=$N>pJs!JI}$H9b$5!K$r(B
       $B0z?t$H$7$FEO$9!#(B
       $B$=$7$F!"(Borg$B2hA|$N#2CM2hA|$r(Bout$B$X:n@.$9$k!#(B
       $B7k2L2hA|$NJ]B8@h$bEO$5$l$F$$$k$3$H$KCm0U$7$F$/$@$5$$(B

       $B#86aK5$N$J$+$K#1$D$G$b9u$$NN0h$,$"$C$?$iCmL\!JCf?42hAG!K$r9u$K$9$k(B
       $B$3$l$G!"Gr$$NN0h$,<}=L$5$l$k$3$H$K$J$k!#(B
       */
{
  int i,j;
  unsigned char max_value,min_value; 

  /*$B#2CM$NCM$b$3$3$G;XDj$9$k!#(Bunsigned char$B$J$N$G!"(B
    $B:GBg(B255, $B:G>.(B0
    */

  max_value = 255;min_value = 0;

  /************ $B$3$3$,%]%$%s%H(B ***************/

  for(i=1;i<h-1;i++){
    for(j=1;j<w-1;j++){

      out[i*w+j]=org[i*w+j];
      if(org[(i-1) * w + j-1] == min_value)  out[i*w +j]=min_value;
      if(org[(i-1) * w + j  ] == min_value)  out[i*w +j]=min_value;
      if(org[(i-1) * w + j+1] == min_value)  out[i*w +j]=min_value;

      if(org[ i    * w + j-1] == min_value)  out[i*w +j]=min_value;

      if(org[ i    * w + j+1] == min_value)  out[i*w +j]=min_value;

      if(org[(i+1) * w + j-1] == min_value)  out[i*w +j]=min_value;
      if(org[(i+1) * w + j  ] == min_value)  out[i*w +j]=min_value;
      if(org[(i+1) * w + j+1] == min_value)  out[i*w +j]=min_value;

      /*$B$3$3$G!"(Bout[i * w + j]$B$,0UL#$9$k$b$N$O(B,
	$B#2<!85$N2hA|$,$9$Y$F#1Ns$K$D$J$,$C$F!"G[Ns$KJ]B8$5$l$F$$$k$?$a(B,
	$B#2<!85E*$K%"%/%;%9$9$k$?$a$K#2=E$N(Bfor$BJ8$r4:$($F:n$C$F$$$^$9!#(B

	$BJQ?t(Bi$B$O2hA|$N=DJ}8~$N0LCV$rI=$7(B,
	$BJQ?t(Bj$B$O2hA|$N2#J}8~$N0LCV$rI=$7$^$9!#(B

	(j, i)$B$H2hA|>e$N:BI8$H9M$($k$H$h$$$G$7$g$&!#(B

	$B$D$.$K!"$3$N2hA|$,$9$Y$F#1Ns$KJB$s$G$$$k$?$a(B,
	(j, i)$BHVCO$K%"%/%;%9$9$k$?$a$K$O!"@hF,$+$i2?8D$a$K$J$k$N$+$r(B
	$B?t$($kI,MW$,$"$j$^$9!#(B
	
	$B$7$?$,$C$F!"(B(j,i)$BHVCO$K$O(B,
	$B=D$,(Bi$B2s(B, $B2#$X(Bj $B%3%^$9$9$`$H9M$($k$H(B,

	i$B2s(B x $B2hA|$N2#I}(B $B!\(B j $B%3%^J,(B

	$B$H%"%/%;%9$9$k$HL\E*$N>l=j$N2hAGCM$,F@$i$l$k(B,
	$B$H$$$&$3$H$K$J$j$^$9!#(B*/
	
      /************$B$3$3$^$G$,%]%$%s%H(B**************/
    }
  }
}


double get_average(unsigned char *in, int w, int h)
{
  int i,pix_size;
  double average;

  pix_size = w*h;  average = 0.0;

  for(i=0;i<pix_size;i++){
    average += in[i];
  }
  return(average/(double)pix_size);
}

void binarize_image(unsigned char *org, unsigned char *out,
		    int w, int h, int threshold)
{
  int i,j;
  unsigned char max_value,min_value; 

  max_value = 255;min_value = 0;
  printf("%d\n",threshold);

  for(i=0;i<h*w;i++){
    
    if(org[i] >=threshold){
      out [i]=max_value;
    }
    else{
      out[i]=min_value;
    }
  }
}


int main(int argc, char **argv) 
{

  double ave_a;

  /*$B2hA|$NI}$H9b$5$NFI$_9~$_(B*/
  get_args(argc, argv);

/*$B2hA|$rJ]B8$9$kG[Ns!J%a%b%jNN0h!K$N=`Hw(B*/
// in $B$K$O862hA|$rF~$l$^$9!#(Boutimg$B$K$O=PNO2hA|$rF~$l$^$9!#(B
// $BBg$-$5$O$$$C$7$g$J$N$GF1$8Bg$-$5$G3NJ]$7$^$9!#(B
  inimg   = (char *)malloc(width*height*sizeof(char));
  outimg  = (char *)malloc(width*height*sizeof(char));

  /*$B2hA|%U%!%$%k$NFI$_9~$_(B*/
  header_size=0;  image_read_char(argv[1],header_size,inimg);
     
  /*$B$^$:2hA|$N2hAGCM$NJ?6Q$r5a$a$^$7$g$&!#(B
    $BF1$8L\E*$J$i(B,$BHFMQ@-$N$"$k#1$D$N4X?t$r$D$/$C$F$=$l$rMxMQ$7$^$7$g$&(B.
    $B862hA|$NJ?6Q$O(Bave_a********/

  ave_a = get_average(inimg,width,height);

  /*$B$3$l$GCM$,JQ?t$KF~NO$5$l$^$7$?!#(B
    $B$D$.$OCM$rI=<($7$F$_$^$9!#(B*/

  /*$BCM$NI=<($O(Bprintf$BJ8$G$G$-$^$9(B*/
  printf("Average pixel value of input image is %f\n",ave_a);


  /* $B#2CM2==hM}$N4X?t$r8F$S!"$=$3$X#2$D$NG[Ns$HI}!"9b$5(B,$B$7$-$$CM$rEO$7$^$9!#(B*/
  binarize_image(inimg, outimg,width,height,(int)ave_a);

  /* erosion$B!J<}=L=hM}!K$r<B9T$7$^$9(B
   $B#2CM2=$N7k2L$O(Boutimg$B$KF~$C$F$$$k$N$G!"(Berosion$B$NF~NO$K$O(B,
   outimg$B$rEO$7$^$9!#=PNO$bG[Ns$rEO$9I,MW$,$"$k$N$G!"(B
   $B$b$&;H$o$J$$(Binimg$B$rEO$7$F$*$-$^$9(B
   */

  erosion(outimg,inimg,width,height);

  /*$B2hA|%U%!%$%k$NJ]B8(B*/
  //$BJL$N%W%m%0%i%`$GI=<($7$F$_$F$/$@$5$$(B
      
  image_write_char(argv[4],width,height,inimg);

  /*$B3NJ]$7$?G[Ns$N2rJ|(B $B!J$d$C$F$b$d$i$J$/$F$b$h$$!K(B*/
  free(outimg);free(inimg);

//$B=*N;;~$K$O#0$rJV$9(B
  return 0;
}
