//all comments and codes by T. Hara

#include <stdio.h>
#include <stdlib.h>

#define USAGE "usage: proc input-filename width height output-filename\n "


/***************
$B#C#A#D%;%_%J!<!?#2CM2hA|$N(Bclosing$B=hM}(B

closing$B=hM}$H$O(B,$B%@%$%l!<%7%g%s=hM}$N8e$K%(%m!<%8%g%s=hM}$r$*$3$J$&=hM}$G$9!#(B
$BA0$N#2$D$N1i=,$rAH$_9g$o$;$k$H40@.$7$^$9!#(B
$B$?$@$7!"4X?t$N8F$SJ}(B,$B0z?t$NEO$7J}$KCm0U$7$F$/$@$5$$!#(B

$B%3%s%Q%$%k$O:#2s(BMakefile$B$rMQ0U$7$?$N$G(B,
$BC1=c$K(B
make $B$HF~NO$7$F$/$@$5$$(B

$B<B9T$9$k$K$O(B,
 proc $BF~NO%U%!%$%kL>(B $B2hA|$NI}(B $B2hA|$N9b$5(B $B=PNO%U%!%$%kL>(B

$B$N=g$GF~NO$7$F$/$@$5$$(B

$B2hA|$r3+$-(B,$BG[Ns$KJ]B8$7$F!"=hM}$7$?7k2L$r=PNO%U%!%$%kL>$r$D$1$F(B
$B%O!<%I%G%#%9%/>e$KJ]B8$7$^$9!#(B

$BJ}?K(B:
$B#2CM2=$O2hA|$NJ?6QCM$G9T$&!#(B
dilation$B$r9T$$(B,
erosion$B$r9T$$(B,
$B$=$N7k2L$rJ]B8$9$k!#(B

$B$K$J$j$^$9!#(B
*****************/

//$BJQ?t$N@k8@(B

int width,height,header_size;
//width, height$B$O$=$l$>$l862hA|$NI}$H9b$5(B

unsigned char *inimg, *outimg;
//inimg$B$O862hA|$rJ]B8$9$kG[Ns!#(Boutimg$B$O=PNO2hA|$rJ]B8!#(B

void image_read_char(char *filename,int offset,unsigned char *im)
{
     FILE *fp;
     if ((fp=fopen(filename,"rb")) == NULL){
       printf("File Open Error Occured!\n");
       exit(-1);
     }
     fseek(fp,offset,0); fread((char *)im,sizeof(char),width*height,fp);
     fclose(fp);
     printf("File Opening...: %s\n",filename);
}

void image_write_char(char *filename,
		      int w, int h,
		      unsigned char *im)
{
    FILE *fp;
    if ((fp=fopen(filename,"wb")) == NULL){
        printf("File Open Error Occured!\n");
        exit(-1);
    }
    fwrite((char *)im,sizeof(char), w * h, fp); fclose(fp);
}


void get_args(int argc, char **argv)
{
  if(argc != 5)
    {
      fprintf(stderr, USAGE);
      exit(1);
    }
  width = atoi(argv[2]); printf("W = %d,", width);
  height = atoi(argv[3]); printf("H = %d,", height);
}

double get_average(unsigned char *in, int w, int h)
{
  int i,pix_size;
  double average;

  pix_size = w*h;  average = 0.0;

  for(i=0;i<pix_size;i++){
    average += in[i];
  }
  return(average/(double)pix_size);
}

void binarize_image(unsigned char *org, unsigned char *out,
		    int w, int h, int threshold)
{
  int i,j;
  unsigned char max_value,min_value; 

  max_value = 255;min_value = 0;
  printf("%d\n",threshold);

  for(i=0;i<h*w;i++){
    
    if(org[i] >=threshold){
      out [i]=max_value;
    }
    else{
      out[i]=min_value;
    }
  }
}


int main(int argc, char **argv) 
{

  double ave_a;

  /*$B2hA|$NI}$H9b$5$NFI$_9~$_(B*/
  get_args(argc, argv);

/*$B2hA|$rJ]B8$9$kG[Ns!J%a%b%jNN0h!K$N=`Hw(B*/
  inimg   = (char *)malloc(width*height*sizeof(char));
  outimg  = (char *)malloc(width*height*sizeof(char));

  /*$B2hA|%U%!%$%k$NFI$_9~$_(B*/
  header_size=0;  image_read_char(argv[1],header_size,inimg);
     
  /*$B$^$:2hA|$N2hAGCM$NJ?6Q$r5a$a$^$7$g$&!#(B
    $B862hA|$NJ?6Q$O(Bave_a********/

  ave_a = get_average(inimg,width,height);

  /*$B$3$l$GCM$,JQ?t$KF~NO$5$l$^$7$?!#$D$.$OCM$rI=<($7$F$_$^$9!#(B*/
  printf("Average pixel value of input image is %f\n",ave_a);

  /* $B#2CM2==hM}$N4X?t$r8F$S!"$=$3$X#2$D$NG[Ns$HI}!"9b$5(B,$B$7$-$$CM$rEO$7$^$9!#(B*/
  binarize_image(inimg, outimg,width,height,(int)ave_a);

  /* $B$^$:(B dilation$B!JKDD%=hM}!K$r9T$$(Berosion$B$r<B9T$7$^$9(B
   $B#2CM2=$N7k2L$O(Boutimg$B$KF~$C$F$$$k$N$G!"(Bdilation$B$NF~NO$K$O(B,
   outimg$B$rEO$7$^$9!#=PNO$bG[Ns$rEO$9I,MW$,$"$k$N$G!"(B
   $B$b$&;H$o$J$$(Binimg$B$rEO$7$F$*$-$^$9(B.
   $B=hM}$rB3$1$F9T$&$N$G#2$D$NG[Ns$NEO$7J}$KCm0U$7$^$7$g$&!#(B
   */

  dilation(outimg,inimg,width,height);
  erosion(inimg,outimg,width,height);

  /*$B2hA|%U%!%$%k$NJ]B8(B*/
  //$BJL$N%W%m%0%i%`$GI=<($7$F$_$F$/$@$5$$(B
      
  image_write_char(argv[4],width,height,outimg);

  /*$B3NJ]$7$?G[Ns$N2rJ|(B $B!J$d$C$F$b$d$i$J$/$F$b$h$$!K(B*/
  free(outimg);free(inimg);

//$B=*N;;~$K$O#0$rJV$9(B
  return 0;
}
