//all comments and codes by T. Hara

#include <stdio.h>
#include <stdlib.h>

#define USAGE "usage: proc input-filename width height output-filename\n "


//$BJQ?t$N@k8@(B

int width,height,header_size,i,j;
unsigned char *inimg, *outimg;

void image_read_char(char *filename,int offset,unsigned char *im)
{
     FILE *fp;
     if ((fp=fopen(filename,"rb")) == NULL){
       printf("File Open Error Occured!\n");
       exit(-1);
     }
     fseek(fp,offset,0); fread((char *)im,sizeof(char),width*height,fp);
     fclose(fp);
     printf("File Opening...: %s\n",filename);
}

void image_write_char(char *filename,
		      int w, int h,
		      unsigned char *im)
{
    FILE *fp;
    if ((fp=fopen(filename,"wb")) == NULL){
        printf("File Open Error Occured!\n");
        exit(-1);
    }
    fwrite((char *)im,sizeof(char), w * h, fp); fclose(fp);
}


void get_args(int argc, char **argv)
{
  if(argc != 5)
    {
      fprintf(stderr, USAGE);
      exit(1);
    }
  width = atoi(argv[2]); printf("W = %d,", width);
  height = atoi(argv[3]); printf("H = %d,", height);
}

double get_average(unsigned char *in, int w, int h)
{
  int i,pix_size;
  double average;

  pix_size = w*h;  average = 0.0;

  for(i=0;i<pix_size;i++){
    average += in[i];
  }
  return(average/(double)pix_size);
}

void binarize_image(unsigned char *org, unsigned char *out,
		    int w, int h, int threshold)
{
  int i,j;
  unsigned char max_value,min_value; 

  max_value = 255;min_value = 0;
  printf("%d\n",threshold);

  for(i=0;i<h*w;i++){
    
    if(org[i] >=threshold){
      out [i]=max_value;
    }
    else{
      out[i]=min_value;
    }
  }
}


int main(int argc, char **argv) 
{

  int number_of_label;//$B%i%Y%k?t$,F~$k(B
  double ave_a;//$BJ?6QCM$,F~$k(B

  get_args(argc, argv);

  inimg   = (char *)malloc(width*height*sizeof(char));
  outimg  = (char *)malloc(width*height*sizeof(char));

  header_size=0;  image_read_char(argv[1],header_size,inimg);

  convolve_smooth(inimg,outimg,width,height);

  ave_a = get_average(outimg,width,height);
  printf("Average pixel value of input image is %f\n",ave_a);

  /* $B#2CM2==hM}$N4X?t$r8F$S!"$=$3$X#2$D$NG[Ns$HI}!"9b$5(B,$B$7$-$$CM$rEO$7$^$9!#(B*/
  binarize_image(outimg,inimg,width,height,(int)ave_a);

  /* erosion$B$r(B1$B2s<B9T(B
     $B$=$N8e(B,dilation$B$r(B1$B2s<B9T(B

   */

  erosion(inimg,outimg,width,height);
  dilation(outimg,inimg,width,height);
  

  /*$B%i%Y%j%s%0$N4X?t$XG[Ns$rEO$7$^$9!#(B
    $BA0$N=hM}$GKDD%<}=L=hM}$N7k2L$,(Boutimg$B$KJ]B8$5$l$F$$$^$9!#(B
    $B$7$?$,$C$F!"=PNO$O$b$&;H$o$J$$(Binimg$B$KF~$k$h$&$K$7$F$*$-$^$9!#(B*/

  number_of_label = labeling(inimg,outimg,width,height);
  printf("The number of labels = %d\n",number_of_label);

  /*$B2hA|%U%!%$%k$NJ]B8(B*/
  //$BJL$N%W%m%0%i%`$GI=<($7$F$_$F$/$@$5$$(B

  image_write_char(argv[4],width,height,outimg);

  /*$B3NJ]$7$?G[Ns$N2rJ|(B $B!J$d$C$F$b$d$i$J$/$F$b$h$$!K(B*/
  free(outimg);free(inimg);

//$B=*N;;~$K$O#0$rJV$9(B
  return 0;
}
