//all comments and codes by T. Hara

#include <stdio.h>
#include <stdlib.h>

#define USAGE "usage: proc input-filename width height output-filename\n "

//$B%W%m%H%?%$%W@k8@(B
void labelsize(unsigned char *img,int label,
	       int width, int height,
	       double *cx, double *cy, int *sqsize);

void surround_length(unsigned char *img,int width,int height,
		       int label, double *length);

void roundshape(unsigned char *label,int width,int height,
		int labelnum,double *ratio);

/***************
$B#C#A#D%;%_%J!<!?#2CM2hA|$N%i%Y%j%s%0=hM}(B

$B%3%s%Q%$%k$O:#2s(BMakefile$B$rMQ0U$7$?$N$G(B,
$BC1=c$K(B
make $B$HF~NO$7$F$/$@$5$$(B

$B<B9T$9$k$K$O(B,
 proc $BF~NO%U%!%$%kL>(B $B2hA|$NI}(B $B2hA|$N9b$5(B $B=PNO%U%!%$%kL>(B

$B$N=g$GF~NO$7$F$/$@$5$$(B

$B2hA|$r3+$-(B,$BG[Ns$KJ]B8$7$F!"=hM}$7$?7k2L$r=PNO%U%!%$%kL>$r$D$1$F(B
$B%i%Y%k2hA|$r%O!<%I%G%#%9%/>e$KJ]B8$7$^$9!#(B

$BJ}?K(B:
$B#2CM2=$O2hA|$NJ?6QCM$G9T$&!#(B
dilation$B$r9T$$(B,
erosion$B$r9T$$(B,
$B%i%Y%k$D$1$r9T$$(B,
$B%i%Y%k?t$H%i%Y%k2hA|$rJ]B8$9$k!#(B

$B$K$J$j$^$9!#(B
*****************/

//$BJQ?t$N@k8@(B

int width,height,header_size,i,j;
//width, height$B$O$=$l$>$l862hA|$NI}$H9b$5(B

unsigned char *inimg, *outimg;
//inimg$B$O862hA|$rJ]B8$9$kG[Ns!#(Boutimg$B$O=PNO2hA|$rJ]B8!#(B

void image_read_char(char *filename,int offset,unsigned char *im)
{
     FILE *fp;
     if ((fp=fopen(filename,"rb")) == NULL){
       printf("File Open Error Occured!\n");
       exit(-1);
     }
     fseek(fp,offset,0); fread((char *)im,sizeof(char),width*height,fp);
     fclose(fp);
     printf("File Opening...: %s\n",filename);
}

void image_write_char(char *filename,
		      int w, int h,
		      unsigned char *im)
{
    FILE *fp;
    if ((fp=fopen(filename,"wb")) == NULL){
        printf("File Open Error Occured!\n");
        exit(-1);
    }
    fwrite((char *)im,sizeof(char), w * h, fp); fclose(fp);
}


void get_args(int argc, char **argv)
{
  if(argc != 5)
    {
      fprintf(stderr, USAGE);
      exit(1);
    }
  width = atoi(argv[2]); printf("W = %d,", width);
  height = atoi(argv[3]); printf("H = %d,", height);
}

double get_average(unsigned char *in, int w, int h)
{
  int i,pix_size;
  double average;

  pix_size = w*h;  average = 0.0;

  for(i=0;i<pix_size;i++){
    average += in[i];
  }
  return(average/(double)pix_size);
}

void binarize_image(unsigned char *org, unsigned char *out,
		    int w, int h, int threshold)
{
  int i,j;
  unsigned char max_value,min_value; 

  max_value = 255;min_value = 0;
  printf("%d\n",threshold);

  for(i=0;i<h*w;i++){
    
    if(org[i] >=threshold){
      out [i]=max_value;
    }
    else{
      out[i]=min_value;
    }
  }
}


int main(int argc, char **argv) 
{

  int i,number_of_label,tmpsize;//$B%i%Y%k?t$J$I$,F~$k(B
  double ave_a,tmpcx, tmpcy, rratio;//$BJ?6QCM(B,$B=E?4$N:BI8$,F~$k(B

  /*$B2hA|$NI}$H9b$5$NFI$_9~$_(B*/
  get_args(argc, argv);

  /*$B2hA|$rJ]B8$9$kG[Ns!J%a%b%jNN0h!K$N=`Hw(B*/
  inimg   = (char *)malloc(width*height*sizeof(char));
  outimg  = (char *)malloc(width*height*sizeof(char));

  /*$B2hA|%U%!%$%k$NFI$_9~$_(B*/
  header_size=0;  image_read_char(argv[1],header_size,inimg);

  /*$B862hA|$NJ?6Q$O(Bave_a********/
  ave_a = get_average(inimg,width,height);
  printf("Average pixel value of input image is %f\n",ave_a);

  /* $B#2CM2==hM}$N4X?t$r8F$S!"$=$3$X#2$D$NG[Ns$HI}!"9b$5(B,$B$7$-$$CM$rEO$7$^$9!#(B*/
  binarize_image(inimg, outimg,width,height,(int)ave_a);

  /* $B$^$:(B dilation$B!JKDD%=hM}!K$r9T$$(Berosion$B$r<B9T$7$^$9(B
   $B=hM}$rB3$1$F9T$&$N$G#2$D$NG[Ns$NEO$7J}$KCm0U$7$^$7$g$&!#(B
   */

  dilation(outimg,inimg,width,height);
  erosion(inimg,outimg,width,height);

  /*$B%i%Y%j%s%0$N4X?t$XG[Ns$rEO$7$^$9!#(B
    $BA0$N=hM}$GKDD%<}=L=hM}$N7k2L$,(Boutimg$B$KJ]B8$5$l$F$$$^$9!#(B
    $B$7$?$,$C$F!"=PNO$O$b$&;H$o$J$$(Binimg$B$KF~$k$h$&$K$7$F$*$-$^$9!#(B*/

  number_of_label = labeling(outimg,inimg,width,height);
  printf("The number of labels = %d\n",number_of_label);

  //$B%i%Y%kHV9f(B i $B$4$H$KFCD'$rCj=P!#$=$7$FI=<((B

      for(i=1;i<number_of_label+1;i++){

	labelsize(inimg,i,width,height,
		  &tmpcx, &tmpcy, &tmpsize);
	printf("Label #=%d, CenterPoint(%lf,%lf), Size=%d,\n",
	       i,tmpcx, tmpcy, tmpsize);
	roundshape(inimg,width,height,i,&rratio);
	printf("Round Radio=%lf\n",rratio);

      }


  /*$B2hA|%U%!%$%k$NJ]B8(B*/
  //$BJL$N%W%m%0%i%`$GI=<($7$F$_$F$/$@$5$$(B
  image_write_char(argv[4],width,height,inimg);

  /*$B3NJ]$7$?G[Ns$N2rJ|(B $B!J$d$C$F$b$d$i$J$/$F$b$h$$!K(B*/
  free(outimg);free(inimg);

//$B=*N;;~$K$O#0$rJV$9(B
  return 0;
}
