#include <stdlib.h>
#include <stdio.h>
#include <GLUT/glut.h>


#define USAGE "usage : ./Image [filename] [width] [height]\n"

/*
#define Scale 1.00
*/

unsigned char *image;

void _init(void);
void _display(void);
void _reshape(int,int);
void _read_image(char *);
int  _file_size(char *);
void _get_args(int argc, char **argv);

int win_height,Height;
int win_width,Width;
double Scale;

GLenum doubleBuffer;

void _read_image(char *filename){
  int i,j;

  FILE *fp;

  if((fp=fopen(filename,"rb"))==NULL){ 
    printf("Error:Can't Read File\n");
    exit(-1);
  }            

  if((fread(image,sizeof(char),Width*Height,fp))!=Width*Height){
    printf("Error:Can't Read File\n");
    fclose(fp);
    exit(-1);
  }       
  fclose(fp);
  printf("Filename: %s\n",filename);

  doubleBuffer = GL_TRUE;
}


void _GL_init(void){    
   glClearColor (0.0, 0.0, 0.0, 0.0);
   glShadeModel(GL_FLAT);
   glPixelStorei(GL_UNPACK_ALIGNMENT, 1);
}

void _GL_display(void){
   glClear(GL_COLOR_BUFFER_BIT);
   glRasterPos2i(0,win_height);

   glPixelZoom((double)win_width/(double)Width,
	       -(double)win_height/(double)Height);

   glDrawPixels(Width,Height,GL_LUMINANCE,GL_UNSIGNED_BYTE,image);

   glutSwapBuffers();
   /*  
   glFlush();
   */
}

void _GL_reshape(int w, int h){

  win_height=h;  win_width=w;

  glViewport(0, 0, (GLsizei) w, (GLsizei) h);
  glMatrixMode(GL_PROJECTION);
  glLoadIdentity();
  gluOrtho2D(0.0, (GLdouble) w, 0.0, (GLdouble) h);
  glMatrixMode(GL_MODELVIEW);
  glLoadIdentity();
}

void _get_args(int argc, char **argv)
{

  if(4!= argc){
    fprintf(stderr,USAGE);
    exit(1);
  }

  Scale =1.0;
  
  Width = atoi(argv[2]); printf("W = %d,", Width);
  Height = atoi(argv[3]); printf("H = %d,", Height);
  /*  Scale = atof(argv[4]); printf("Zoom = %f\n",Scale);*/

}

static void Key(unsigned char key, int x, int y)
{
    (void) x; 
    (void) y;
    switch (key) {
      case 27:
        exit(1);
      case 'q':
        exit(1);

      default:
        return;
    }
}

static void Mouse(int button, int state, int mouseX, int mouseY)
{
    if (state != GLUT_DOWN)
        return;
	printf("(x,y) = (%d,%d) Pix Value = %d\n",mouseX,mouseY,image[mouseY * Width + mouseX]);

}




int main(int argc, char **argv){

  GLenum type;

  _get_args(argc, argv);
  image=(unsigned char *)calloc(Width*Height,sizeof(char));

  _read_image(argv[1]);

  glutInit(&argc, argv);

  type = GLUT_RGB;
  type |= (doubleBuffer) ? GLUT_DOUBLE : GLUT_SINGLE;
  glutInitDisplayMode(type);
  glutInitWindowSize(Width*Scale,Height*Scale);
  /*  glutInitWindowPosition(100, 100);*/
  glutCreateWindow(argv[0]);
  glutKeyboardFunc(Key);
  glutMouseFunc(Mouse);

  _GL_init();
  glutDisplayFunc(_GL_display);
  glutReshapeFunc(_GL_reshape);
  glutMainLoop();

  free(image);
  return 0; 
}
